<script>
// import { ValidationObserver } from 'vee-validate'
// import {
//   BAlert,
//   BButton,
//   BCol,
//   BForm,
//   BFormCheckbox,
//   BFormGroup,
//   BFormInput,
//   BFormTextarea,
//   BRow,
//   BSpinner,
// } from 'bootstrap-vue'
//
// import { email, required } from '@validations'
import UserApiV1 from '@/api/userApi'

export default {
  name: 'EditUserForm',
  components: {
    ValidationObserver,
    BAlert,
    BForm,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BButton,
    BSpinner,
    BFormTextarea,
    BFormCheckbox,
  },
  props: {
    ldapData: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      user: { username: '', rol: '' },
      optionsRol: [
        { value: null, text: 'Please select some item' },
        { value: 'USER', text: 'Operator' },
        { value: 'DEVELOPER', text: 'Developer' },
        { value: 'ADMIN', text: 'Administrator' },
      ],
      required,
      email,
      saving: false,
      isRequest: false,
      isError: false,
      requestMessage: '',
    }
  },
  computed: {
    alertToggleVariant() {
      return this.isError ? 'danger' : 'success'
    },
    alertToggleText() {
      return this.isError ? 'Error!' : 'Success!'
    },
    prepareOptionsRol() {
      const options = this.optionsRol
      if (this.user.rol.toLowerCase() === 'root')
        options.push({ value: 'ROOT', text: 'root' })

      return options
    },
  },
  mounted() {
    this.user = this.$store.state.user
  },
  methods: {
    async saveUser() {
      this.saving = true
      console.log('this.ldapData: ', this.ldapData)

      const users = new UserApiV1()
      try {
        this.responseldapData = await users.updateUser(this.ldapData)
        console.log('responseldapData: ', JSON.parse(JSON.stringify(this.responseldapData.data)))
        this.requestMessage = this.responseldapData.data.message
        this.isError = false
      }
      catch (error) {
        console.log('error getUserById', error)
        this.requestMessage = error.response.data.message
        this.isError = true
      }
      this.saving = false
      this.isRequest = true
    },
  },
}
</script>

<template>
  <ValidationObserver ref="simpleRules">
    <BForm class="mt-2">
      <BRow>
        <!-- Label -->
        <BCol sm="6">
          <BFormGroup
            label="Label"
            label-for="label"
          >
            <BFormInput
              v-model="ldapData.label"
              placeholder="Enter Label"
              name="label"
              required
            />
            <small
              id="hostHelp"
              class="form-text text-muted"
            >
              A human-friendly name for your LDAP server. It is displayed on your sign-in page.
              Example: 'Paris' or 'Acme, Ltd.'
            </small>
          </BFormGroup>
        </BCol>

        <!-- Host -->
        <BCol sm="6">
          <BFormGroup
            label="Host"
            label-for="host"
          >
            <BFormInput
              v-model="ldapData.host"
              placeholder="Enter Host"
              name="host"
              required
            />
            <small
              id="hostHelp"
              class="form-text text-muted"
            >
              IP address or domain name of your LDAP server. Ignored when hosts are defined.
              Example: 'ldap.mydomain.com'
            </small>
          </BFormGroup>
        </BCol>

        <!-- Port -->
        <BCol sm="6">
          <BFormGroup
            label="Port"
            label-for="port"
          >
            <BFormInput
              v-model="ldapData.port"
              placeholder="Enter Port"
              name="port"
              required
            />
            <small
              id="portHelp"
              class="form-text text-muted"
            >
              The port to connect with on your LDAP server. Ignored when hosts are defined.
              Example: 389 or 636 (for SSL)
            </small>
          </BFormGroup>
        </BCol>

        <!-- UID -->
        <BCol sm="6">
          <BFormGroup
            label="UID"
            label-for="uid"
          >
            <BFormInput
              v-model="ldapData.uid"
              placeholder="Enter UID"
              name="uid"
              required
            />
            <small
              id="uidHelp"
              class="form-text text-muted"
            >
              The LDAP attribute that maps to the username that users use to sign in.
              Should be the attribute, not the value that maps to the uid.
              Does not affect the anaframework username (see attributes section).
              Example: 'sAMAccountName' or 'uid' or 'userPrincipalName'
            </small>
          </BFormGroup>
        </BCol>

        <!-- Base -->
        <BCol sm="6">
          <BFormGroup
            label="Base"
            label-for="base"
          >
            <BFormInput
              v-model="ldapData.base"
              placeholder="Enter Base"
              name="base"
              required
            />
            <small
              id="baseHelp"
              class="form-text text-muted"
            >
              Base where we can search for users.
              Example: 'ou=people,dc=anaframework,dc=example' or 'DC=mydomain,DC=com'
            </small>
          </BFormGroup>
        </BCol>

        <!-- Encryption -->
        <BCol sm="6">
          <BFormGroup
            label="Encryption"
            label-for="encryption"
          >
            <BFormInput
              v-model="ldapData.encryption"
              placeholder="Enter Encryption"
              name="encryption"
              required
            />
            <small
              id="encryptionHelp"
              class="form-text text-muted"
            >
              Encryption method (the method key is deprecated in favor of encryption).
              It can have one of three values: 'start_tls', 'simple_tls', or 'plain'.
              simple_tls corresponds to ‘Simple TLS’ in the LDAP library.
              start_tls corresponds to StartTLS, not to be confused with regular TLS.
              If you specify simple_tls, usually it’s on port 636, while start_tls (StartTLS) would be on port 389.
              plain also operates on port 389.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Hosts -->
        <BCol sm="6">
          <BFormGroup
            label="Hosts"
            label-for="hosts"
          >
            <BFormTextarea
              v-model="ldapData.hosts"
              placeholder="Enter Hosts"
              name="hosts"
              required
            />

            <small
              id="hostsHelp"
              class="form-text text-muted"
            >
              An array of host and port pairs to open connections.
              Each configured server should have an identical data set.
              This is not meant to configure multiple distinct LDAP servers, but to configure failover.
              Hosts are tried in the order they are configured.
              Example: [['ldap1.mydomain.com', 636], ['ldap2.mydomain.com', 636]]
            </small>
          </BFormGroup>
        </BCol>

        <!-- Bind DN -->
        <BCol sm="6">
          <BFormGroup
            label="Bind DN"
            label-for="bind_dn"
          >
            <BFormInput
              v-model="ldapData.bind_dn"
              placeholder="Enter Bind DN"
              name="bind_dn"
              required
            />
            <small
              id="bindDnHelp"
              class="form-text text-muted"
            >
              The full DN of the user you bind with.
              Example: 'america\momo' or 'CN=anaframework,OU=Users,DC=domain,DC=com'
            </small>
          </BFormGroup>
        </BCol>

        <!-- Password -->
        <BCol sm="6">
          <BFormGroup
            label="Password"
            label-for="password"
          >
            <BFormInput
              v-model="ldapData.password"
              placeholder="Enter Password"
              name="password"
              required
            />
            <small
              id="passwordHelp"
              class="form-text text-muted"
            >
              The password of the bind user.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Verify Certificates -->
        <BCol sm="6">
          <BFormGroup
            label="Verify Certificates"
            label-for="verify_certificates"
          >
            <BFormCheckbox
              v-model="ldapData.verify_certificates"
              required
            >
              Verify Certificates
            </BFormCheckbox>

            <small
              id="verifyCertificatesHelp"
              class="form-text text-muted"
            >
              Defaults to true. Enables SSL certificate verification if encryption method is start_tls or simple_tls.
              If set to false, no validation of the LDAP server’s SSL certificate is performed.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Timeout -->
        <BCol sm="6">
          <BFormGroup
            label="Timeout"
            label-for="timeout"
          >
            <BFormInput
              v-model="ldapData.timeout"
              placeholder="Enter Timeout"
              name="timeout"
              required
            />
            <small
              id="timeoutHelp"
              class="form-text text-muted"
            >
              Defaults to 10. Set a timeout, in seconds, for LDAP queries.
              This helps avoid blocking a request if the LDAP server becomes unresponsive.
              A value of 0 means there is no timeout.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Active Directory -->
        <BCol sm="6">
          <BFormGroup
            label="Active Directory"
            label-for="active_directory"
          >
            <BFormCheckbox
              v-model="ldapData.active_directory"
              required
            >
              Active Directory
            </BFormCheckbox>

            <small
              id="activeDirectoryHelp"
              class="form-text text-muted"
            >
              This setting specifies if LDAP server is Active Directory LDAP server.
              For non-AD servers it skips the AD specific queries. If your LDAP server is not AD, set this to false.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Allow Username or Email Login -->
        <BCol sm="6">
          <BFormGroup
            label="Allow Username or Email Login"
            label-for="allow_username_or_email_login"
          >
            <BFormCheckbox
              v-model="ldapData.allow_username_or_email_login"
              required
            >
              Allow Username or Email Login
            </BFormCheckbox>

            <small
              id="allowUsernameOrEmailLoginHelp"
              class="form-text text-muted"
            >
              Defaults to false. If enabled, anaframework ignores everything after the first @ in the LDAP username
              submitted by the user on sign-in. If you are using uid: 'userPrincipalName' on ActiveDirectory you must
              disable this setting, because the userPrincipalName contains an @.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Block Auto Created Users -->
        <BCol sm="6">
          <BFormGroup
            label="Block Auto Created Users"
            label-for="block_auto_created_users"
          >
            <BFormCheckbox
              v-model="ldapData.block_auto_created_users"
              required
            >
              Block Auto Created Users
            </BFormCheckbox>

            <small
              id="blockAutoCreatedUsersHelp"
              class="form-text text-muted"
            >
              Defaults to false.
              To maintain tight control over the number of billable users on your anaframework installation,
              enable this setting to keep new users blocked until they have been cleared by an administrator.
            </small>
          </BFormGroup>
        </BCol>

        <!-- User Filter -->
        <BCol sm="6">
          <BFormGroup
            label="User Filter"
            label-for="user_filter"
          >
            <BFormInput
              v-model="ldapData.user_filter"
              placeholder="Enter User Filter"
              name="user_filter"
              required
            />
            <small
              id="userFilterHelp"
              class="form-text text-muted"
            >
              Filter LDAP users.
              Follows the format of RFC 4515. anaframework does not support omniauth-ldap’s custom filter syntax.
              Examples of the user_filter field syntax:
              - '(employeeType=developer)'
              - '(&(objectclass=user)(|(samaccountname=momo)(samaccountname=toto)))'
            </small>
          </BFormGroup>
        </BCol>

        <!-- Lowercase Usernames -->
        <BCol sm="6">
          <BFormGroup
            label="Lowercase Usernames"
            label-for="lowercase_usernames"
          >
            <BFormCheckbox
              v-model="ldapData.lowercase_usernames"
              required
            >
              Lowercase Usernames
            </BFormCheckbox>

            <small
              id="lowercaseUsernamesHelp"
              class="form-text text-muted"
            >
              If enabled, anaframework converts the name to lowercase.
            </small>
          </BFormGroup>
        </BCol>

        <!-- Retry Empty Result with Codes -->
        <BCol sm="6">
          <BFormGroup
            label="Retry Empty Result with Codes"
            label-for="retry_empty_result_with_codes"
          >
            <BFormInput
              v-model="ldapData.retry_empty_result_with_codes"
              placeholder="Enter Retry Empty Result with Codes"
              name="retry_empty_result_with_codes"
              required
            />
            <small
              id="retryEmptyResultWithCodesHelp"
              class="form-text text-muted"
            >
              An array of LDAP query response codes that attempt to retry the operation if the result/content is empty.
              For Google Secure LDAP, set this value to [80].
            </small>
          </BFormGroup>
        </BCol>

        <BCol md="12">
          <BAlert
            v-if="isRequest"
            :variant="alertToggleVariant"
            show
          >
            <div class="alert-body">
              <FeatherIcon
                icon="InfoIcon"
                class="mr-50"
              />
              <span><strong>{{ alertToggleText }}</strong> {{ requestMessage }}.</span>
            </div>
          </BAlert>
        </BCol>
        <BCol cols="12">
          <BButton
            variant="primary"
            class="mt-2 mr-1"
            :disabled="saving"
            @click="saveUser"
          >
            <BSpinner
              v-if="saving"
              small
            />
            <span v-if="saving"> Saving... </span>
            <span v-else> Save changes </span>
          </BButton>
        </BCol>
      </BRow>
    </BForm>
  </ValidationObserver>
</template>

<style scoped>

</style>
